using System.ComponentModel;

namespace GridGroupingRebind
{
	public class PrimaryItems : BindingList<PrimaryItem>
	{
		private static PrimaryItems m_Instance = null;

		public static PrimaryItems Instance
		{
			get
			{
				if (m_Instance == null)
				{
					m_Instance = new PrimaryItems();
				}
				return m_Instance;
			}
		}
	}

	public class SecondaryItems : BindingList<SecondaryItem>
	{
	}

	public class PrimaryItem
	{
		private string m_Name;
		private string m_Price;
		private string m_Qty;

		private SecondaryItems m_Items = new SecondaryItems();

		public string Name
		{
			get { return m_Name; }
			set { m_Name = value; }
		}

		public string Price
		{
			get { return m_Price; }
			set { m_Price = value; }
		}

		public string Qty
		{
			get { return m_Qty; }
			set { m_Qty = value; }
		}

		public SecondaryItems Items
		{
			get { return m_Items; }
			set { m_Items = value; }
		}

		public PrimaryItem(string aName, string aPrice, string aQty)
		{
			m_Name = aName;
			m_Price = aPrice;
			m_Qty = aQty;
		}
	}

	public class SecondaryItem
	{
		private string m_Number01;
		private string m_Number02;

		public string Number01
		{
			get { return m_Number01; }
			set { m_Number01 = value; }
		}

		public string Number02
		{
			get { return m_Number02; }
			set { m_Number02 = value; }
		}
		public SecondaryItem(string aN1, string aN2)
		{
			m_Number01 = aN1;
			m_Number02 = aN2;
		}

	}
}