#region Copyright Syncfusion Inc. 2001 - 2008

//
//  Copyright Syncfusion Inc. 2001 - 2008. All rights reserved.
//
//  Use of this code is subject to the terms of our license.
//  A copy of the current license can be obtained at any time by e-mailing
//  licensing@syncfusion.com. Any infringement will be prosecuted under
//  applicable laws. 
//

#endregion

using System;
using System.ComponentModel;
using System.Drawing;
using System.IO;
using System.Windows.Forms;
using Syncfusion.Grouping;
using Syncfusion.Windows.Forms;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms.Grid.Grouping;

namespace GridGroupingRebind
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : Form
	{
		private GridGroupingControl gridGroupingControl1;
		private Button button1;
		private IContainer components;

		public Form1()
		{
			// Debug helpers to see when objects are created and destroyed (work only for debug builds
			// of libraries).
			RelationDescriptorCollection.VerboseEnsureInitialized = true;
			Engine.VerboseEnsureObjectLifeTime = true;
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose(bool disposing)
		{
			if (disposing)
			{
				if (components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose(disposing);
		}

		#region Windows Form Designer generated code

		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.gridGroupingControl1 = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
			this.button1 = new System.Windows.Forms.Button();
			((System.ComponentModel.ISupportInitialize)(this.gridGroupingControl1)).BeginInit();
			this.SuspendLayout();
			// 
			// gridGroupingControl1
			// 
			this.gridGroupingControl1.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
						| System.Windows.Forms.AnchorStyles.Left)
						| System.Windows.Forms.AnchorStyles.Right)));
			this.gridGroupingControl1.BackColor = System.Drawing.SystemColors.Window;
			this.gridGroupingControl1.ChildGroupOptions.ShowAddNewRecordBeforeDetails = false;
			this.gridGroupingControl1.ChildGroupOptions.ShowCaption = true;
			this.gridGroupingControl1.Font = new System.Drawing.Font("Verdana", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.gridGroupingControl1.ForeColor = System.Drawing.Color.MidnightBlue;
			this.gridGroupingControl1.GridVisualStyles = Syncfusion.Windows.Forms.GridVisualStyles.Office2007Blue;
			this.gridGroupingControl1.Location = new System.Drawing.Point(12, 40);
			this.gridGroupingControl1.Name = "gridGroupingControl1";
			this.gridGroupingControl1.Size = new System.Drawing.Size(576, 393);
			this.gridGroupingControl1.TabIndex = 0;
			this.gridGroupingControl1.TableOptions.GridLineBorder = new Syncfusion.Windows.Forms.Grid.GridBorder(Syncfusion.Windows.Forms.Grid.GridBorderStyle.Solid, System.Drawing.Color.FromArgb(((int)(((byte)(208)))), ((int)(((byte)(215)))), ((int)(((byte)(229))))));
			this.gridGroupingControl1.Text = "gridGroupingControl1";
			this.gridGroupingControl1.TopLevelGroupOptions.ShowAddNewRecordBeforeDetails = false;
			// 
			// button1
			// 
			this.button1.Location = new System.Drawing.Point(12, 11);
			this.button1.Name = "button1";
			this.button1.Size = new System.Drawing.Size(75, 23);
			this.button1.TabIndex = 1;
			this.button1.Text = "Add Element";
			this.button1.UseVisualStyleBackColor = true;
			this.button1.Click += new System.EventHandler(this.button1_Click);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(600, 445);
			this.Controls.Add(this.button1);
			this.Controls.Add(this.gridGroupingControl1);
			this.Name = "Form1";
			this.Text = "GridGroupingRebind...";
			this.Load += new System.EventHandler(this.Form1_Load);
			((System.ComponentModel.ISupportInitialize)(this.gridGroupingControl1)).EndInit();
			this.ResumeLayout(false);

		}

		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		private static void Main()
		{
			Application.EnableVisualStyles();
			Application.Run(new Form1());
		}

		private void Form1_Load(object sender, EventArgs e)
		{
			this.gridGroupingControl1.DataSource = PrimaryItems.Instance;
			this.gridGroupingControl1.AllowedOptimizations = EngineOptimizations.All;
			GridEngine engine = this.gridGroupingControl1.Engine;
			engine.TableOptions.ShowRowHeader = false;
			engine.TableOptions.RecordRowHeight = 30;
			engine.TableOptions.GridLineBorder = new GridBorder(GridBorderStyle.Solid, SystemColors.ActiveBorder);
			engine.TopLevelGroupOptions.ShowCaption = false;
			engine.TopLevelGroupOptions.ShowSummaries = false;
			engine.TopLevelGroupOptions.ShowAddNewRecordAfterDetails = false;
			engine.TopLevelGroupOptions.ShowAddNewRecordBeforeDetails = false;
			engine.ChildGroupOptions.ShowCaption = false;
			engine.ChildGroupOptions.ShowSummaries = false;
			engine.ChildGroupOptions.ShowAddNewRecordAfterDetails = false;
			engine.ChildGroupOptions.ShowAddNewRecordBeforeDetails = false;
			engine.NestedTableGroupOptions.ShowCaption = false;
			engine.NestedTableGroupOptions.ShowSummaries = false;
			engine.NestedTableGroupOptions.ShowAddNewRecordAfterDetails = false;
			engine.NestedTableGroupOptions.ShowAddNewRecordBeforeDetails = false;

			// Optimization options from syncfusion sample
			gridGroupingControl1.CounterLogic = EngineCounters.YAmount;
			gridGroupingControl1.AllowedOptimizations = EngineOptimizations.DisableCounters | EngineOptimizations.RecordsAsDisplayElements;
			// to multiline records to be displayed
			//fa@ ggdComplexOrderbook.UseDefaultsForFasterDrawing = true; // GDI interop drawing, FirstNRecords Summaries
			gridGroupingControl1.InvalidateAllWhenListChanged = false; // only paint modified cells 
			gridGroupingControl1.InsertRemoveBehavior = GridListChangedInsertRemoveBehavior.ScrollWithImmediateUpdate;
			gridGroupingControl1.UpdateDisplayFrequency = 500; // update every number of ms (speciy 0 if Update should occur manually, 1 if immediately)
			gridGroupingControl1.TableControl.EnableDoubleBufferSurface(); // reduce flickering
			gridGroupingControl1.BlinkTime = 700;

			// Instruct grouping control not to access datasource through
			// CurrencyManager API and instead access list diretly. When set to
			// false you wil howver loose support for built-in CurrencyManager 
			// synchronization.
			gridGroupingControl1.BindToCurrencyManager = false;

			if (typeof(object).AssemblyQualifiedName.IndexOf("Version=1") == -1)
			{
				// .NET 2.0 gets very slow when subscribing to ListChanged event on the 
				// DataTable.DefaultView. The following setting allows the engine to wrap 
				// datatable with a Syncfusion.Collections.DataTableList to work around 
				// this bottleneck.
				//
				// .NET 1.0 and 1.1 are just fine with using DataTable.DefaultView
				//
				// if uncomment no nested grid be displayed
				gridGroupingControl1.AllowSwapDataViewWithDataTableList = true;
			}
		}

		private void button1_Click(object sender, EventArgs e)
		{
			SecondaryItem s1 = new SecondaryItem("1", "1");
			SecondaryItem s2 = new SecondaryItem("2", "2");
			SecondaryItem s3 = new SecondaryItem("3", "3");
			SecondaryItem s4 = new SecondaryItem("4", "4");
			PrimaryItem p1 = new PrimaryItem("A", "11.0", "100");
			PrimaryItem p2 = new PrimaryItem("B", "12.0", "100");
			p1.Items.Add(s1);
			PrimaryItems.Instance.Add(p1);
			PrimaryItems.Instance.Add(p2);
			p1.Items.Add(s2);
			p2.Items.Add(s3);
			p2.Items.Add(s4);
		}

	}
}